## GtkTreeModelFilter

GtkTreeModelFilter

## Functions

gboolean | (*GtkTreeModelFilterVisibleFunc) ()
void | (*GtkTreeModelFilterModifyFunc) ()
GtkTreeModel * | gtk_tree_model_filter_new ()
void | gtk_tree_model_filter_set_visible_func ()
void | gtk_tree_model_filter_set_modify_func ()
void | gtk_tree_model_filter_set_visible_column ()
GtkTreeModel * | gtk_tree_model_filter_get_model ()
gboolean | gtk_tree_model_filter_convert_child_iter_to_iter ()
void | gtk_tree_model_filter_convert_iter_to_child_iter ()
GtkTreePath * | gtk_tree_model_filter_convert_child_path_to_path ()
GtkTreePath * | gtk_tree_model_filter_convert_path_to_child_path ()
void | gtk_tree_model_filter_refilter ()
void | gtk_tree_model_filter_clear_cache ()

## Properties

GtkTreeModel * | child-model | Read / Write / Construct Only
GtkTreePath * | virtual-root | Read / Write / Construct Only

## Types and Values

struct | GtkTreeModelFilter

## Object Hierarchy

        GObject
        ╰── GtkTreeModelFilter

## Implemented Interfaces

GtkTreeModelFilter implements GtkTreeModel and GtkTreeDragSource.

## Includes

    #include <gtk/gtk.h>

## Description

## Functions

### GtkTreeModelFilterVisibleFunc ()

    gboolean
    (*GtkTreeModelFilterVisibleFunc) (GtkTreeModel *model,
                                      GtkTreeIter *iter,
                                      gpointer data);

### GtkTreeModelFilterModifyFunc ()

    void
    (*GtkTreeModelFilterModifyFunc) (GtkTreeModel *model,
                                     GtkTreeIter *iter,
                                     GValue *value,
                                     gint column,
                                     gpointer data);

### gtk_tree_model_filter_new ()

    GtkTreeModel *
    gtk_tree_model_filter_new (GtkTreeModel *child_model,
                               GtkTreePath *root);

Creates a new GtkTreeModel, with `child_model` as the child_model and `root` as the virtual root.

#### Parameters

child_model | A GtkTreeModel. |
root | A GtkTreePath or `NULL`. | [allow-none]

#### Returns

A new GtkTreeModel.

[transfer full]

Since: 2.4

### gtk_tree_model_filter_set_visible_func ()

    void
    gtk_tree_model_filter_set_visible_func
                                   (GtkTreeModelFilter *filter,
                                    GtkTreeModelFilterVisibleFunc func,
                                    gpointer data,
                                    GDestroyNotify destroy);

Sets the visible function used when filtering the `filter` to be `func` . The function should return `TRUE` if the given row should be visible and `FALSE` otherwise.

If the condition calculated by the function changes over time (e.g. because it depends on some global parameters), you must call `gtk_tree_model_filter_refilter()` to keep the visibility information of the model uptodate.

Note that `func` is called whenever a row is inserted, when it may still be empty. The visible function should therefore take special care of empty rows, like in the example below.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16

    static gboolean
    visible_func (GtkTreeModel *model,
                  GtkTreeIter  *iter,
                  gpointer      data)
    {
      /* Visible if row is non-empty and first column is "HI" */
      gchar *str;
      gboolean visible = FALSE;

      gtk_tree_model_get (model, iter, 0, &str, -1);
      if (str && strcmp (str, "HI") == 0)
        visible = TRUE;
      g_free (str);

      return visible;
    }

#### Parameters

filter | A GtkTreeModelFilter. |
func | A GtkTreeModelFilterVisibleFunc, the visible function. |
data | User data to pass to the visible function, or `NULL`. | [allow-none]
destroy | Destroy notifier of `data` , or `NULL`. | [allow-none]

Since: 2.4

### gtk_tree_model_filter_set_modify_func ()

    void
    gtk_tree_model_filter_set_modify_func (GtkTreeModelFilter *filter,
                                           gint n_columns,
                                           GType *types,
                                           GtkTreeModelFilterModifyFunc func,
                                           gpointer data,
                                           GDestroyNotify destroy);

With the `n_columns` and `types` parameters, you give an array of column types for this model (which will be exposed to the parent model/view). The `func` , `data` and `destroy` parameters are for specifying the modify function. The modify function will get called for each data access, the goal of the modify function is to return the data which should be displayed at the location specified using the parameters of the modify function.

#### Parameters

filter | A GtkTreeModelFilter. |
n_columns | The number of columns in the filter model. |
types | The GTypes of the columns. | [array length=n_columns]
func | A GtkTreeModelFilterModifyFunc |
data | User data to pass to the modify function, or `NULL`. | [allow-none]
destroy | Destroy notifier of `data` , or `NULL`. | [allow-none]

Since: 2.4

### gtk_tree_model_filter_set_visible_column ()

    void
    gtk_tree_model_filter_set_visible_column
                                   (GtkTreeModelFilter *filter,
                                    gint column);

Sets `column` of the child_model to be the column where `filter` should look for visibility information. `columns` should be a column of type `G_TYPE_BOOLEAN`, where `TRUE` means that a row is visible, and `FALSE` if not.

#### Parameters

filter | A GtkTreeModelFilter. |
column | A gint which is the column containing the visible information. |

Since: 2.4

### gtk_tree_model_filter_get_model ()

    GtkTreeModel *
    gtk_tree_model_filter_get_model (GtkTreeModelFilter *filter);

Returns a pointer to the child model of `filter` .

#### Parameters

filter | A GtkTreeModelFilter. |

#### Returns

A pointer to a GtkTreeModel.

[transfer none]

Since: 2.4

### gtk_tree_model_filter_convert_child_iter_to_iter ()

    gboolean
    gtk_tree_model_filter_convert_child_iter_to_iter
                                   (GtkTreeModelFilter *filter,
                                    GtkTreeIter *filter_iter,
                                    GtkTreeIter *child_iter);

Sets `filter_iter` to point to the row in `filter` that corresponds to the row pointed at by `child_iter` . If `filter_iter` was not set, `FALSE` is returned.

#### Parameters

filter | A GtkTreeModelFilter. |
filter_iter | An uninitialized GtkTreeIter. | [out]
child_iter | A valid GtkTreeIter pointing to a row on the child model. |

#### Returns

`TRUE`, if `filter_iter` was set, i.e. if `child_iter` is a valid iterator pointing to a visible row in child model.

Since: 2.4

### gtk_tree_model_filter_convert_iter_to_child_iter ()

    void
    gtk_tree_model_filter_convert_iter_to_child_iter
                                   (GtkTreeModelFilter *filter,
                                    GtkTreeIter *child_iter,
                                    GtkTreeIter *filter_iter);

Sets `child_iter` to point to the row pointed to by `filter_iter` .

#### Parameters

filter | A GtkTreeModelFilter. |
child_iter | An uninitialized GtkTreeIter. | [out]
filter_iter | A valid GtkTreeIter pointing to a row on `filter` . |

Since: 2.4

### gtk_tree_model_filter_convert_child_path_to_path ()

    GtkTreePath *
    gtk_tree_model_filter_convert_child_path_to_path
                                   (GtkTreeModelFilter *filter,
                                    GtkTreePath *child_path);

Converts `child_path` to a path relative to `filter` . That is, `child_path` points to a path in the child model. The rerturned path will point to the same row in the filtered model. If `child_path` isn't a valid path on the child model or points to a row which is not visible in `filter` , then `NULL` is returned.

#### Parameters

filter | A GtkTreeModelFilter. |
child_path | A GtkTreePath to convert. |

#### Returns

A newly allocated GtkTreePath, or `NULL`.

Since: 2.4

### gtk_tree_model_filter_convert_path_to_child_path ()

    GtkTreePath *
    gtk_tree_model_filter_convert_path_to_child_path
                                   (GtkTreeModelFilter *filter,
                                    GtkTreePath *filter_path);

Converts `filter_path` to a path on the child model of `filter` . That is, `filter_path` points to a location in `filter` . The returned path will point to the same location in the model not being filtered. If `filter_path` does not point to a location in the child model, `NULL` is returned.

#### Parameters

filter | A GtkTreeModelFilter. |
filter_path | A GtkTreePath to convert. |

#### Returns

A newly allocated GtkTreePath, or `NULL`.

Since: 2.4

### gtk_tree_model_filter_refilter ()

    void
    gtk_tree_model_filter_refilter (GtkTreeModelFilter *filter);

Emits ::row_changed for each row in the child model, which causes the filter to re-evaluate whether a row is visible or not.

#### Parameters

filter | A GtkTreeModelFilter. |

Since: 2.4

### gtk_tree_model_filter_clear_cache ()

    void
    gtk_tree_model_filter_clear_cache (GtkTreeModelFilter *filter);

This function should almost never be called. It clears the `filter` of any cached iterators that haven't been reffed with `gtk_tree_model_ref_node()`. This might be useful if the child model being filtered is static (and doesn't change often) and there has been a lot of unreffed access to nodes. As a side effect of this function, all unreffed iters will be invalid.

#### Parameters

filter | A GtkTreeModelFilter. |

Since: 2.4

## Types and Values

### struct GtkTreeModelFilter

    struct GtkTreeModelFilter;

## Property Details

### The `“child-model”` property

      “child-model”              GtkTreeModel *

The model for the filtermodel to filter.

Owner: GtkTreeModelFilter

Flags: Read / Write / Construct Only

### The `“virtual-root”` property

      “virtual-root”             GtkTreePath *

The virtual root (relative to the child model) for this filtermodel.

Owner: GtkTreeModelFilter

Flags: Read / Write / Construct Only